Index: serefpolicy-contrib-20140730/vmware.te
===================================================================
--- serefpolicy-contrib-20140730.orig/vmware.te
+++ serefpolicy-contrib-20140730/vmware.te
@@ -65,7 +65,8 @@ ifdef(`enable_mcs',`
 # Host local policy
 #
 
-allow vmware_host_t self:capability { setgid setuid net_raw sys_nice sys_time sys_ptrace kill dac_override };
+allow vmware_host_t self:capability { net_admin sys_module };
+allow vmware_host_t self:capability { setgid setuid net_raw sys_nice sys_time kill dac_override };
 dontaudit vmware_host_t self:capability sys_tty_config;
 allow vmware_host_t self:process { execstack execmem signal_perms };
 allow vmware_host_t self:fifo_file rw_fifo_file_perms;
@@ -94,8 +95,8 @@ can_exec(vmware_host_t, vmware_host_exec
 kernel_read_kernel_sysctls(vmware_host_t)
 kernel_read_system_state(vmware_host_t)
 kernel_read_network_state(vmware_host_t)
+kernel_request_load_module(vmware_host_t)
 
-corenet_all_recvfrom_unlabeled(vmware_host_t)
 corenet_all_recvfrom_netlabel(vmware_host_t)
 corenet_tcp_sendrecv_generic_if(vmware_host_t)
 corenet_udp_sendrecv_generic_if(vmware_host_t)
@@ -115,14 +116,13 @@ dev_getattr_all_blk_files(vmware_host_t)
 dev_read_sysfs(vmware_host_t)
 dev_read_urand(vmware_host_t)
 dev_rw_vmware(vmware_host_t)
+dev_rw_generic_chr_files(vmware_host_t)
 
 domain_use_interactive_fds(vmware_host_t)
 domain_dontaudit_read_all_domains_state(vmware_host_t)
 
 files_list_tmp(vmware_host_t)
-files_read_etc_files(vmware_host_t)
 files_read_etc_runtime_files(vmware_host_t)
-files_read_usr_files(vmware_host_t)
 
 fs_getattr_all_fs(vmware_host_t)
 fs_search_auto_mountpoints(vmware_host_t)
@@ -138,23 +138,27 @@ libs_exec_ld_so(vmware_host_t)
 
 logging_send_syslog_msg(vmware_host_t)
 
-miscfiles_read_localization(vmware_host_t)
-
 sysnet_dns_name_resolve(vmware_host_t)
 sysnet_domtrans_ifconfig(vmware_host_t)
 
+systemd_start_power_services(vmware_host_t)
+
 userdom_dontaudit_use_unpriv_user_fds(vmware_host_t)
 userdom_dontaudit_search_user_home_dirs(vmware_host_t)
 
 netutils_domtrans_ping(vmware_host_t)
 
 optional_policy(`
-	hostname_exec(vmware_host_t)
+	unconfined_domain(vmware_host_t)
 ')
 
 optional_policy(`
+	hostname_exec(vmware_host_t)
+') 
+
+optional_policy(`
 	modutils_domtrans_insmod(vmware_host_t)
-')
+') 
 
 optional_policy(`
 	samba_read_config(vmware_host_t)
@@ -244,9 +248,7 @@ dev_search_sysfs(vmware_t)
 
 domain_use_interactive_fds(vmware_t)
 
-files_read_etc_files(vmware_t)
 files_read_etc_runtime_files(vmware_t)
-files_read_usr_files(vmware_t)
 files_list_home(vmware_t)
 
 fs_getattr_all_fs(vmware_t)
@@ -258,9 +260,8 @@ storage_raw_write_removable_device(vmwar
 libs_exec_ld_so(vmware_t)
 libs_read_lib_files(vmware_t)
 
-miscfiles_read_localization(vmware_t)
 
-userdom_use_user_terminals(vmware_t)
+userdom_use_inherited_user_terminals(vmware_t)
 userdom_list_user_home_dirs(vmware_t)
 
 sysnet_dns_name_resolve(vmware_t)
Index: serefpolicy-contrib-20140730/vnstatd.if
===================================================================
--- serefpolicy-contrib-20140730.orig/vnstatd.if
+++ serefpolicy-contrib-20140730/vnstatd.if
@@ -157,7 +157,6 @@ interface(`vnstatd_manage_lib_files',`
 ##	Role allowed access.
 ##	</summary>
 ## </param>
-## <rolecap/>
 #
 interface(`vnstatd_admin',`
 	gen_require(`
@@ -165,9 +164,13 @@ interface(`vnstatd_admin',`
 		type vnstatd_var_run_t;
 	')
 
-	allow $1 vnstatd_t:process { ptrace signal_perms };
+	allow $1 vnstatd_t:process signal_perms;
 	ps_process_pattern($1, vnstatd_t)
 
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 vnstatd_t:process ptrace;
+	')
+
 	init_labeled_script_domtrans($1, vnstatd_initrc_exec_t)
 	domain_system_change_exemption($1)
 	role_transition $2 vnstatd_initrc_exec_t system_r;
Index: serefpolicy-contrib-20140730/vnstatd.te
===================================================================
--- serefpolicy-contrib-20140730.orig/vnstatd.te
+++ serefpolicy-contrib-20140730/vnstatd.te
@@ -36,7 +36,7 @@ allow vnstatd_t self:unix_stream_socket
 
 manage_dirs_pattern(vnstatd_t, vnstatd_var_lib_t, vnstatd_var_lib_t)
 manage_files_pattern(vnstatd_t, vnstatd_var_lib_t, vnstatd_var_lib_t)
-files_var_lib_filetrans(vnstatd_t, vnstatd_var_lib_t, { dir file })
+files_var_lib_filetrans(vnstatd_t, vnstatd_var_lib_t, dir)
 
 manage_files_pattern(vnstatd_t, vnstatd_var_run_t, vnstatd_var_run_t)
 manage_dirs_pattern(vnstatd_t, vnstatd_var_run_t, vnstatd_var_run_t)
@@ -47,14 +47,10 @@ kernel_read_system_state(vnstatd_t)
 
 domain_use_interactive_fds(vnstatd_t)
 
-files_read_etc_files(vnstatd_t)
-
 fs_getattr_xattr_fs(vnstatd_t)
 
 logging_send_syslog_msg(vnstatd_t)
 
-miscfiles_read_localization(vnstatd_t)
-
 ########################################
 #
 # Client local policy
@@ -64,23 +60,19 @@ allow vnstat_t self:process signal;
 allow vnstat_t self:fifo_file rw_fifo_file_perms;
 allow vnstat_t self:unix_stream_socket { accept listen };
 
+files_search_var_lib(vnstat_t)
 manage_dirs_pattern(vnstat_t, vnstatd_var_lib_t, vnstatd_var_lib_t)
 manage_files_pattern(vnstat_t, vnstatd_var_lib_t, vnstatd_var_lib_t)
-files_var_lib_filetrans(vnstat_t, vnstatd_var_lib_t, { dir file })
 
 kernel_read_network_state(vnstat_t)
 kernel_read_system_state(vnstat_t)
 
 domain_use_interactive_fds(vnstat_t)
 
-files_read_etc_files(vnstat_t)
-
 fs_getattr_xattr_fs(vnstat_t)
 
 logging_send_syslog_msg(vnstat_t)
 
-miscfiles_read_localization(vnstat_t)
-
 optional_policy(`
 	cron_system_entry(vnstat_t, vnstat_exec_t)
 ')
Index: serefpolicy-contrib-20140730/vpn.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/vpn.fc
+++ serefpolicy-contrib-20140730/vpn.fc
@@ -1,7 +1,13 @@
-/sbin/vpnc	--	gen_context(system_u:object_r:vpnc_exec_t,s0)
+#
+# sbin
+#
+/sbin/vpnc		--	gen_context(system_u:object_r:vpnc_exec_t,s0)
 
+#
+# /usr
+#
 /usr/bin/openconnect	--	gen_context(system_u:object_r:vpnc_exec_t,s0)
 
-/usr/sbin/vpnc	--	gen_context(system_u:object_r:vpnc_exec_t,s0)
+/usr/sbin/vpnc		--	gen_context(system_u:object_r:vpnc_exec_t,s0)
 
-/var/run/vpnc(/.*)?	gen_context(system_u:object_r:vpnc_var_run_t,s0)
+/var/run/vpnc(/.*)?		gen_context(system_u:object_r:vpnc_var_run_t,s0)
Index: serefpolicy-contrib-20140730/vpn.if
===================================================================
--- serefpolicy-contrib-20140730.orig/vpn.if
+++ serefpolicy-contrib-20140730/vpn.if
@@ -1,8 +1,8 @@
-## <summary>Virtual Private Networking client.</summary>
+## <summary>Virtual Private Networking client</summary>
 
 ########################################
 ## <summary>
-##	Execute vpn clients in the vpnc domain.
+##	Execute VPN clients in the vpnc domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -15,15 +15,13 @@ interface(`vpn_domtrans',`
 		type vpnc_t, vpnc_exec_t;
 	')
 
-	corecmd_search_bin($1)
 	domtrans_pattern($1, vpnc_exec_t, vpnc_t)
 ')
 
 ########################################
 ## <summary>
-##	Execute vpn clients in the vpnc
-##	domain, and allow the specified
-##	role the vpnc domain.
+##	Execute VPN clients in the vpnc domain, and
+##	allow the specified role the vpnc domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -40,6 +38,7 @@ interface(`vpn_domtrans',`
 interface(`vpn_run',`
 	gen_require(`
 		attribute_role vpnc_roles;
+		type vpnc_t;
 	')
 
 	vpn_domtrans($1)
@@ -48,7 +47,7 @@ interface(`vpn_run',`
 
 ########################################
 ## <summary>
-##	Send kill signals to vpnc.
+##	Send VPN clients the kill signal.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -66,7 +65,7 @@ interface(`vpn_kill',`
 
 ########################################
 ## <summary>
-##	Send generic signals to vpnc.
+##	Send generic signals to VPN clients.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -84,7 +83,7 @@ interface(`vpn_signal',`
 
 ########################################
 ## <summary>
-##	Send null signals to vpnc.
+##	Send signull to VPN clients.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -103,7 +102,7 @@ interface(`vpn_signull',`
 ########################################
 ## <summary>
 ##	Send and receive messages from
-##	vpnc over dbus.
+##	Vpnc over dbus.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
Index: serefpolicy-contrib-20140730/vpn.te
===================================================================
--- serefpolicy-contrib-20140730.orig/vpn.te
+++ serefpolicy-contrib-20140730/vpn.te
@@ -6,6 +6,7 @@ policy_module(vpn, 1.16.0)
 #
 
 attribute_role vpnc_roles;
+roleattribute system_r vpnc_roles;
 
 type vpnc_t;
 type vpnc_exec_t;
@@ -28,9 +29,13 @@ allow vpnc_t self:capability { dac_read_
 allow vpnc_t self:process { getsched signal };
 allow vpnc_t self:fifo_file rw_fifo_file_perms;
 allow vpnc_t self:netlink_route_socket rw_netlink_socket_perms;
-allow vpnc_t self:tcp_socket { accept listen };
+allow vpnc_t self:tcp_socket create_stream_socket_perms;
+allow vpnc_t self:udp_socket create_socket_perms;
 allow vpnc_t self:rawip_socket create_socket_perms;
+allow vpnc_t self:unix_dgram_socket create_socket_perms;
+allow vpnc_t self:unix_stream_socket create_socket_perms;
 allow vpnc_t self:tun_socket { create_socket_perms relabelfrom };
+# cjp: this needs to be fixed
 allow vpnc_t self:socket create_socket_perms;
 
 manage_dirs_pattern(vpnc_t, vpnc_tmp_t, vpnc_tmp_t)
@@ -47,7 +52,6 @@ kernel_read_all_sysctls(vpnc_t)
 kernel_request_load_module(vpnc_t)
 kernel_rw_net_sysctls(vpnc_t)
 
-corenet_all_recvfrom_unlabeled(vpnc_t)
 corenet_all_recvfrom_netlabel(vpnc_t)
 corenet_tcp_sendrecv_generic_if(vpnc_t)
 corenet_udp_sendrecv_generic_if(vpnc_t)
@@ -58,38 +62,32 @@ corenet_raw_sendrecv_generic_node(vpnc_t
 corenet_tcp_sendrecv_all_ports(vpnc_t)
 corenet_udp_sendrecv_all_ports(vpnc_t)
 corenet_udp_bind_generic_node(vpnc_t)
-
-corenet_sendrecv_all_server_packets(vpnc_t)
 corenet_udp_bind_generic_port(vpnc_t)
-
-corenet_sendrecv_isakmp_server_packets(vpnc_t)
 corenet_udp_bind_isakmp_port(vpnc_t)
-
-corenet_sendrecv_generic_server_packets(vpnc_t)
 corenet_udp_bind_ipsecnat_port(vpnc_t)
-
-corenet_sendrecv_all_client_packets(vpnc_t)
 corenet_tcp_connect_all_ports(vpnc_t)
-
+corenet_sendrecv_all_client_packets(vpnc_t)
+corenet_sendrecv_isakmp_server_packets(vpnc_t)
+corenet_sendrecv_generic_server_packets(vpnc_t)
 corenet_rw_tun_tap_dev(vpnc_t)
 
-corecmd_exec_all_executables(vpnc_t)
-
 dev_read_rand(vpnc_t)
 dev_read_urand(vpnc_t)
 dev_read_sysfs(vpnc_t)
 
 domain_use_interactive_fds(vpnc_t)
 
-files_exec_etc_files(vpnc_t)
-files_read_etc_runtime_files(vpnc_t)
-files_dontaudit_search_home(vpnc_t)
-
 fs_getattr_xattr_fs(vpnc_t)
 fs_getattr_tmpfs(vpnc_t)
 
-term_use_all_ptys(vpnc_t)
-term_use_all_ttys(vpnc_t)
+term_use_all_inherited_ptys(vpnc_t)
+term_use_all_inherited_ttys(vpnc_t)
+
+corecmd_exec_all_executables(vpnc_t)
+
+files_exec_etc_files(vpnc_t)
+files_read_etc_runtime_files(vpnc_t)
+files_dontaudit_search_home(vpnc_t)
 
 auth_use_nsswitch(vpnc_t)
 
@@ -103,16 +101,15 @@ locallogin_use_fds(vpnc_t)
 logging_send_syslog_msg(vpnc_t)
 logging_dontaudit_search_logs(vpnc_t)
 
-miscfiles_read_localization(vpnc_t)
-
-seutil_dontaudit_search_config(vpnc_t)
+seutil_use_newrole_fds(vpnc_t)
 
 sysnet_run_ifconfig(vpnc_t, vpnc_roles)
 sysnet_etc_filetrans_config(vpnc_t)
 sysnet_manage_config(vpnc_t)
 
 userdom_use_all_users_fds(vpnc_t)
-userdom_dontaudit_search_user_home_content(vpnc_t)
+userdom_read_home_certs(vpnc_t)
+userdom_search_admin_dir(vpnc_t)
 
 optional_policy(`
 	dbus_system_bus_client(vpnc_t)
@@ -124,8 +121,5 @@ optional_policy(`
 
 optional_policy(`
 	networkmanager_attach_tun_iface(vpnc_t)
-')
-
-optional_policy(`
-	seutil_use_newrole_fds(vpnc_t)
+	networkmanager_manage_pid_files(vpnc_t)
 ')
Index: serefpolicy-contrib-20140730/w3c.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/w3c.fc
+++ serefpolicy-contrib-20140730/w3c.fc
@@ -1,4 +1,4 @@
-/usr/lib/cgi-bin/check	--	gen_context(system_u:object_r:httpd_w3c_validator_script_exec_t,s0)
+/usr/lib/cgi-bin/check	--	gen_context(system_u:object_r:w3c_validator_script_exec_t,s0)
 
-/usr/share/w3c-markup-validator(/.*)?	gen_context(system_u:object_r:httpd_w3c_validator_content_t,s0)
-/usr/share/w3c-markup-validator/cgi-bin(/.*)?	gen_context(system_u:object_r:httpd_w3c_validator_script_exec_t,s0)
+/usr/share/w3c-markup-validator(/.*)?	gen_context(system_u:object_r:w3c_validator_content_t,s0)
+/usr/share/w3c-markup-validator/cgi-bin(/.*)?	gen_context(system_u:object_r:w3c_validator_script_exec_t,s0)
Index: serefpolicy-contrib-20140730/w3c.te
===================================================================
--- serefpolicy-contrib-20140730.orig/w3c.te
+++ serefpolicy-contrib-20140730/w3c.te
@@ -6,29 +6,37 @@ policy_module(w3c, 1.1.0)
 #
 
 apache_content_template(w3c_validator)
+apache_content_alias_template(w3c_validator, w3c_validator)
+
+type w3c_validator_tmp_t;
+files_tmp_file(w3c_validator_tmp_t)
 
 ########################################
 #
 # Local policy
 #
+manage_dirs_pattern(w3c_validator_script_t, w3c_validator_tmp_t, w3c_validator_tmp_t)
+manage_files_pattern(w3c_validator_script_t, w3c_validator_tmp_t, w3c_validator_tmp_t)
+files_tmp_filetrans(w3c_validator_script_t, w3c_validator_tmp_t, { file dir })
+
+
+corenet_all_recvfrom_unlabeled(w3c_validator_script_t)
+corenet_all_recvfrom_netlabel(w3c_validator_script_t)
+corenet_tcp_sendrecv_generic_if(w3c_validator_script_t)
+corenet_tcp_sendrecv_generic_node(w3c_validator_script_t)
+
+corenet_sendrecv_ftp_client_packets(w3c_validator_script_t)
+corenet_tcp_connect_ftp_port(w3c_validator_script_t)
+corenet_tcp_sendrecv_ftp_port(w3c_validator_script_t)
+
+corenet_sendrecv_http_client_packets(w3c_validator_script_t)
+corenet_tcp_connect_http_port(w3c_validator_script_t)
+corenet_tcp_sendrecv_http_port(w3c_validator_script_t)
 
-corenet_all_recvfrom_unlabeled(httpd_w3c_validator_script_t)
-corenet_all_recvfrom_netlabel(httpd_w3c_validator_script_t)
-corenet_tcp_sendrecv_generic_if(httpd_w3c_validator_script_t)
-corenet_tcp_sendrecv_generic_node(httpd_w3c_validator_script_t)
-
-corenet_sendrecv_ftp_client_packets(httpd_w3c_validator_script_t)
-corenet_tcp_connect_ftp_port(httpd_w3c_validator_script_t)
-corenet_tcp_sendrecv_ftp_port(httpd_w3c_validator_script_t)
-
-corenet_sendrecv_http_client_packets(httpd_w3c_validator_script_t)
-corenet_tcp_connect_http_port(httpd_w3c_validator_script_t)
-corenet_tcp_sendrecv_http_port(httpd_w3c_validator_script_t)
-
-corenet_sendrecv_http_cache_client_packets(httpd_w3c_validator_script_t)
-corenet_tcp_connect_http_cache_port(httpd_w3c_validator_script_t)
-corenet_tcp_sendrecv_http_cache_port(httpd_w3c_validator_script_t)
+corenet_sendrecv_http_cache_client_packets(w3c_validator_script_t)
+corenet_tcp_connect_http_cache_port(w3c_validator_script_t)
+corenet_tcp_sendrecv_http_cache_port(w3c_validator_script_t)
 
-miscfiles_read_generic_certs(httpd_w3c_validator_script_t)
+miscfiles_read_generic_certs(w3c_validator_script_t)
 
-sysnet_dns_name_resolve(httpd_w3c_validator_script_t)
+sysnet_dns_name_resolve(w3c_validator_script_t)
Index: serefpolicy-contrib-20140730/watchdog.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/watchdog.fc
+++ serefpolicy-contrib-20140730/watchdog.fc
@@ -1,7 +1,12 @@
 /etc/rc\.d/init\.d/watchdog	--	gen_context(system_u:object_r:watchdog_initrc_exec_t,s0)
+/etc/watchdog\.d(/.*)?       gen_context(system_u:object_r:watchdog_unconfined_exec_t,s0)
 
 /usr/sbin/watchdog	--	gen_context(system_u:object_r:watchdog_exec_t,s0)
 
+/usr/libexec/watchdog/scripts(/.*)?       gen_context(system_u:object_r:watchdog_unconfined_exec_t,s0)
+
+/var/cache/watchdog(/.*)?   gen_context(system_u:object_r:watchdog_cache_t,s0)
+
 /var/log/watchdog.*	gen_context(system_u:object_r:watchdog_log_t,s0)
 
 /var/run/watchdog\.pid	--	gen_context(system_u:object_r:watchdog_var_run_t,s0)
Index: serefpolicy-contrib-20140730/watchdog.te
===================================================================
--- serefpolicy-contrib-20140730.orig/watchdog.te
+++ serefpolicy-contrib-20140730/watchdog.te
@@ -1,4 +1,4 @@
-policy_module(watchdog, 1.9.0)
+policy_module(watchdog, 1.8.0)
 
 #################################
 #
@@ -12,12 +12,18 @@ init_daemon_domain(watchdog_t, watchdog_
 type watchdog_initrc_exec_t;
 init_script_file(watchdog_initrc_exec_t)
 
+type watchdog_cache_t;
+files_type(watchdog_cache_t)
+
 type watchdog_log_t;
 logging_log_file(watchdog_log_t)
 
 type watchdog_var_run_t;
 files_pid_file(watchdog_var_run_t)
 
+type watchdog_unconfined_exec_t;
+application_executable_file(watchdog_unconfined_exec_t)
+
 ########################################
 #
 # Local policy
@@ -27,11 +33,15 @@ allow watchdog_t self:capability { sys_a
 dontaudit watchdog_t self:capability sys_tty_config;
 allow watchdog_t self:process { setsched signal_perms };
 allow watchdog_t self:fifo_file rw_fifo_file_perms;
-allow watchdog_t self:rawip_socket create_socket_perms;
 allow watchdog_t self:tcp_socket { accept listen };
+allow watchdog_t self:rawip_socket create_socket_perms;
+
+manage_files_pattern(watchdog_t, watchdog_cache_t, watchdog_cache_t)
+manage_dirs_pattern(watchdog_t, watchdog_cache_t, watchdog_cache_t)
 
-allow watchdog_t watchdog_log_t:file { append_file_perms create_file_perms setattr_file_perms };
-logging_log_filetrans(watchdog_t, watchdog_log_t, file)
+manage_files_pattern(watchdog_t,watchdog_log_t,watchdog_log_t)
+manage_dirs_pattern(watchdog_t,watchdog_log_t,watchdog_log_t)
+logging_log_filetrans(watchdog_t, watchdog_log_t,{dir file})
 
 manage_files_pattern(watchdog_t, watchdog_var_run_t, watchdog_var_run_t)
 files_pid_filetrans(watchdog_t, watchdog_var_run_t, file)
@@ -65,7 +75,6 @@ domain_signull_all_domains(watchdog_t)
 domain_signal_all_domains(watchdog_t)
 domain_kill_all_domains(watchdog_t)
 
-files_read_etc_files(watchdog_t)
 files_manage_etc_runtime_files(watchdog_t)
 files_etc_filetrans_etc_runtime(watchdog_t, file)
 
@@ -74,17 +83,20 @@ fs_getattr_all_fs(watchdog_t)
 fs_search_auto_mountpoints(watchdog_t)
 
 auth_append_login_records(watchdog_t)
+auth_read_passwd(watchdog_t)
 
 logging_send_syslog_msg(watchdog_t)
 
-miscfiles_read_localization(watchdog_t)
-
 sysnet_dns_name_resolve(watchdog_t)
 
 userdom_dontaudit_use_unpriv_user_fds(watchdog_t)
 userdom_dontaudit_search_user_home_dirs(watchdog_t)
 
 optional_policy(`
+    cron_system_entry(watchdog_t, watchdog_exec_t)
+')
+
+optional_policy(`
 	mta_send_mail(watchdog_t)
 ')
 
@@ -99,3 +111,28 @@ optional_policy(`
 optional_policy(`
 	udev_read_db(watchdog_t)
 ')
+
+########################################
+#
+# watchdog_unconfined_script_t local policy
+#
+
+optional_policy(`
+	type watchdog_unconfined_t;
+	domain_type(watchdog_unconfined_t)
+
+	domain_entry_file(watchdog_unconfined_t, watchdog_unconfined_exec_t)
+	role system_r types watchdog_unconfined_t;
+
+	domtrans_pattern(watchdog_t, watchdog_unconfined_exec_t, watchdog_unconfined_t)
+
+	allow watchdog_t watchdog_unconfined_exec_t:dir search_dir_perms;
+	allow watchdog_t watchdog_unconfined_exec_t:dir read_file_perms;
+	allow watchdog_t watchdog_unconfined_exec_t:file ioctl;
+
+	init_domtrans_script(watchdog_unconfined_t)
+
+	optional_policy(`
+		unconfined_domain(watchdog_unconfined_t)
+	')
+')
Index: serefpolicy-contrib-20140730/wdmd.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/wdmd.fc
+++ serefpolicy-contrib-20140730/wdmd.fc
@@ -1,5 +1,7 @@
 /etc/rc\.d/init\.d/wdmd	--	gen_context(system_u:object_r:wdmd_initrc_exec_t,s0)
 
-/usr/sbin/wdmd	--	gen_context(system_u:object_r:wdmd_exec_t,s0)
+/usr/sbin/wdmd		--	gen_context(system_u:object_r:wdmd_exec_t,s0)
+
+/var/run/wdmd(/.*)?		gen_context(system_u:object_r:wdmd_var_run_t,s0)
+/var/run/checkquorum-timer  --  gen_context(system_u:object_r:wdmd_var_run_t,s0)
 
-/var/run/wdmd(/.*)?	gen_context(system_u:object_r:wdmd_var_run_t,s0)
Index: serefpolicy-contrib-20140730/wdmd.if
===================================================================
--- serefpolicy-contrib-20140730.orig/wdmd.if
+++ serefpolicy-contrib-20140730/wdmd.if
@@ -1,29 +1,47 @@
-## <summary>Watchdog multiplexing daemon.</summary>
+
+## <summary>watchdog multiplexing daemon</summary>
 
 ########################################
 ## <summary>
-##	Connect to wdmd with a unix
-##	domain stream socket.
+##	Execute a domain transition to run wdmd.
 ## </summary>
 ## <param name="domain">
-##	<summary>
+## <summary>
 ##	Domain allowed access.
+## </summary>
+## </param>
+#
+interface(`wdmd_domtrans',`
+	gen_require(`
+		type wdmd_t, wdmd_exec_t;
+	')
+
+	domtrans_pattern($1, wdmd_exec_t, wdmd_t)
+')
+
+
+########################################
+## <summary>
+##	Execute wdmd server in the wdmd domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	The type of the process performing this action.
 ##	</summary>
 ## </param>
 #
-interface(`wdmd_stream_connect',`
+interface(`wdmd_initrc_domtrans',`
 	gen_require(`
-		type wdmd_t, wdmd_var_run_t;
+		type wdmd_initrc_exec_t;
 	')
 
-	files_search_pids($1)
-	stream_connect_pattern($1, wdmd_var_run_t, wdmd_var_run_t, wdmd_t)
+	init_labeled_script_domtrans($1, wdmd_initrc_exec_t)
 ')
 
 ########################################
 ## <summary>
-##	All of the rules required to
-##	administrate an wdmd environment.
+##	All of the rules required to administrate
+##	an wdmd environment
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -39,17 +57,77 @@ interface(`wdmd_stream_connect',`
 #
 interface(`wdmd_admin',`
 	gen_require(`
-		type wdmd_t, wdmd_initrc_exec_t, wdmd_var_run_t;
+		type wdmd_t;
+		type wdmd_initrc_exec_t;
 	')
 
-	allow $1 wdmd_t:process { ptrace signal_perms };
+	allow $1 wdmd_t:process signal_perms;
 	ps_process_pattern($1, wdmd_t)
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 wdmd_t:process ptrace;
+	')
 
-	init_labeled_script_domtrans($1, wdmd_initrc_exec_t)
+	wdmd_initrc_domtrans($1)
 	domain_system_change_exemption($1)
 	role_transition $2 wdmd_initrc_exec_t system_r;
 	allow $2 system_r;
 
+')
+
+######################################
+## <summary>
+##	Create, read, write, and delete wdmd PID files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`wdmd_manage_pid_files',`
+	gen_require(`
+		type wdmd_var_run_t;
+	')
+
 	files_search_pids($1)
-	admin_pattern($1, wdmd_var_run_t)
+	manage_files_pattern($1, wdmd_var_run_t, wdmd_var_run_t)
+')
+
+########################################
+## <summary>
+##      Connect to wdmd over a unix stream socket.
+## </summary>
+## <param name="domain">
+##      <summary>
+##      Domain allowed access.
+##      </summary>
+## </param>
+#
+interface(`wdmd_stream_connect',`
+        gen_require(`
+                type wdmd_t, wdmd_var_run_t;
+        ')
+
+        files_search_pids($1)
+        stream_connect_pattern($1, wdmd_var_run_t, wdmd_var_run_t, wdmd_t)
+')
+
+
+####################################
+## <summary>
+##  Allow the specified domain to read/write wdmd's tmpfs files.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+#
+interface(`wdmd_rw_tmpfs',`
+    gen_require(`
+        type wdmd_tmpfs_t;
+    ')
+
+    rw_files_pattern($1, wdmd_tmpfs_t, wdmd_tmpfs_t)
+
 ')
Index: serefpolicy-contrib-20140730/wdmd.te
===================================================================
--- serefpolicy-contrib-20140730.orig/wdmd.te
+++ serefpolicy-contrib-20140730/wdmd.te
@@ -45,16 +45,15 @@ corecmd_exec_shell(wdmd_t)
 dev_read_watchdog(wdmd_t)
 dev_write_watchdog(wdmd_t)
 
+fs_getattr_all_fs(wdmd_t)
 fs_read_anon_inodefs_files(wdmd_t)
 
 auth_use_nsswitch(wdmd_t)
 
 logging_send_syslog_msg(wdmd_t)
 
-miscfiles_read_localization(wdmd_t)
-
 optional_policy(`
-	corosync_initrc_domtrans(wdmd_t)
-	corosync_stream_connect(wdmd_t)
-	corosync_rw_tmpfs(wdmd_t)
+	rhcs_initrc_domtrans_cluster(wdmd_t)
+	rhcs_stream_connect_cluster(wdmd_t)
+	rhcs_rw_cluster_tmpfs(wdmd_t)
 ')
Index: serefpolicy-contrib-20140730/webadm.te
===================================================================
--- serefpolicy-contrib-20140730.orig/webadm.te
+++ serefpolicy-contrib-20140730/webadm.te
@@ -25,6 +25,9 @@ role webadm_r;
 
 userdom_base_user_template(webadm)
 
+type webadm_tmp_t;
+files_tmp_file(webadm_tmp_t)
+
 ########################################
 #
 # Local policy
@@ -32,6 +35,12 @@ userdom_base_user_template(webadm)
 
 allow webadm_t self:capability { dac_override dac_read_search kill sys_nice };
 
+manage_dirs_pattern(webadm_t, webadm_tmp_t, webadm_tmp_t)
+manage_files_pattern(webadm_t, webadm_tmp_t, webadm_tmp_t)
+manage_lnk_files_pattern(webadm_t, webadm_tmp_t, webadm_tmp_t)
+files_tmp_filetrans(webadm_t, webadm_tmp_t, { file dir })
+can_exec(webadm_t, webadm_tmp_t)
+
 files_dontaudit_search_all_dirs(webadm_t)
 files_list_var(webadm_t)
 
@@ -43,7 +52,9 @@ logging_send_syslog_msg(webadm_t)
 
 userdom_dontaudit_search_user_home_dirs(webadm_t)
 
-apache_admin(webadm_t, webadm_r)
+optional_policy(`
+	apache_admin(webadm_t, webadm_r)
+')
 
 tunable_policy(`webadm_manage_user_files',`
 	userdom_manage_user_home_content_files(webadm_t)
Index: serefpolicy-contrib-20140730/webalizer.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/webalizer.fc
+++ serefpolicy-contrib-20140730/webalizer.fc
@@ -6,4 +6,4 @@
 
 /var/lib/webalizer(/.*)?	gen_context(system_u:object_r:webalizer_var_lib_t,s0)
 
-/var/www/usage(/.*)?	gen_context(system_u:object_r:httpd_webalizer_content_t,s0)
+/var/www/usage(/.*)?	gen_context(system_u:object_r:webalizer_rw_content_t,s0)
Index: serefpolicy-contrib-20140730/webalizer.te
===================================================================
--- serefpolicy-contrib-20140730.orig/webalizer.te
+++ serefpolicy-contrib-20140730/webalizer.te
@@ -55,29 +55,36 @@ can_exec(webalizer_t, webalizer_exec_t)
 kernel_read_kernel_sysctls(webalizer_t)
 kernel_read_system_state(webalizer_t)
 
-files_read_etc_runtime_files(webalizer_t)
+corenet_all_recvfrom_netlabel(webalizer_t)
+corenet_tcp_sendrecv_generic_if(webalizer_t)
+corenet_tcp_sendrecv_generic_node(webalizer_t)
+corenet_tcp_sendrecv_all_ports(webalizer_t)
 
 fs_search_auto_mountpoints(webalizer_t)
 fs_getattr_xattr_fs(webalizer_t)
 fs_rw_anon_inodefs_files(webalizer_t)
 
-auth_use_nsswitch(webalizer_t)
+files_read_etc_runtime_files(webalizer_t)
 
 logging_list_logs(webalizer_t)
 logging_send_syslog_msg(webalizer_t)
 
-miscfiles_read_localization(webalizer_t)
+auth_use_nsswitch(webalizer_t)
+
 miscfiles_read_public_files(webalizer_t)
 
-userdom_use_user_terminals(webalizer_t)
+sysnet_dns_name_resolve(webalizer_t)
+sysnet_read_config(webalizer_t)
+
+userdom_use_inherited_user_terminals(webalizer_t)
 userdom_use_unpriv_users_fds(webalizer_t)
 userdom_dontaudit_search_user_home_content(webalizer_t)
 
 optional_policy(`
 	apache_read_log(webalizer_t)
 	apache_content_template(webalizer)
-	manage_dirs_pattern(webalizer_t, httpd_webalizer_content_t, httpd_webalizer_content_t)
-	manage_files_pattern(webalizer_t, httpd_webalizer_content_t, httpd_webalizer_content_t)
+	apache_content_alias_template(webalizer, webalizer)
+	apache_manage_sys_content(webalizer_t)
 ')
 
 optional_policy(`
